Liferay.Loader.define("dynamic-data-mapping-form-field-type@5.0.83/FieldSet/FieldSet.es", ['module', 'exports', 'require', './FieldSet.scss', 'dynamic-data-mapping-form-renderer', 'frontend-js-react-web$react', '../FieldBase/ReactFieldBase.es', './Panel.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    require("./FieldSet.scss");

    var _dynamicDataMappingFormRenderer = require("dynamic-data-mapping-form-renderer");

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _ReactFieldBase = require("../FieldBase/ReactFieldBase.es");

    var _Panel = _interopRequireDefault(require("./Panel.es"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _extends() {
      _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }return target;
      };return _extends.apply(this, arguments);
    }

    function _objectWithoutProperties(source, excluded) {
      if (source == null) return {};var target = _objectWithoutPropertiesLoose(source, excluded);var key, i;if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);for (i = 0; i < sourceSymbolKeys.length; i++) {
          key = sourceSymbolKeys[i];if (excluded.indexOf(key) >= 0) continue;if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;target[key] = source[key];
        }
      }return target;
    }

    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null) return {};var target = {};var sourceKeys = Object.keys(source);var key, i;for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];if (excluded.indexOf(key) >= 0) continue;target[key] = source[key];
      }return target;
    }

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    var getRowsArray = function getRowsArray(rows) {
      if (typeof rows === 'string') {
        try {
          return JSON.parse(rows);
        } catch (e) {
          return [];
        }
      }

      return rows;
    };

    var getRows = function getRows(rows, nestedFields) {
      var normalizedRows = getRowsArray(rows);
      return normalizedRows.map(function (row) {
        return _objectSpread(_objectSpread({}, row), {}, {
          columns: row.columns.map(function (column) {
            return _objectSpread(_objectSpread({}, column), {}, {
              fields: nestedFields.filter(function (nestedField) {
                return column.fields.includes(nestedField.fieldName);
              })
            });
          })
        });
      });
    };

    var FieldSet = function FieldSet(_ref) {
      var collapsible = _ref.collapsible,
          label = _ref.label,
          name = _ref.name,
          _ref$nestedFields = _ref.nestedFields,
          nestedFields = _ref$nestedFields === void 0 ? [] : _ref$nestedFields,
          readOnly = _ref.readOnly,
          repeatable = _ref.repeatable,
          rows = _ref.rows,
          showLabel = _ref.showLabel,
          otherProps = _objectWithoutProperties(_ref, ["collapsible", "label", "name", "nestedFields", "readOnly", "repeatable", "rows", "showLabel"]);

      var repeatedIndex = (0, _react.useMemo)(function () {
        return (0, _dynamicDataMappingFormRenderer.getRepeatedIndex)(name);
      }, [name]);

      var renderLayout = function renderLayout(_ref2) {
        var ddmStructureId = _ref2.ddmStructureId,
            type = _ref2.type;
        return (/*#__PURE__*/_react.default.createElement(_dynamicDataMappingFormRenderer.Layout, {
            editable: type === 'fieldset' && !ddmStructureId,
            rows: getRows(rows, nestedFields)
          })
        );
      };

      return (/*#__PURE__*/_react.default.createElement(_ReactFieldBase.FieldBase, _extends({}, otherProps, {
          name: name,
          readOnly: readOnly,
          repeatable: collapsible ? false : repeatable,
          required: false,
          showLabel: false
        }), /*#__PURE__*/_react.default.createElement("div", {
          className: "ddm-field-types-fieldset__nested"
        }, showLabel && !collapsible && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("label", {
          className: "text-uppercase"
        }, label), /*#__PURE__*/_react.default.createElement("div", {
          className: "ddm-field-types-fieldset__nested-separator"
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: "mt-1 separator"
        }))), collapsible ? /*#__PURE__*/_react.default.createElement(_Panel.default, {
          name: name,
          readOnly: readOnly,
          repeatable: repeatable,
          showLabel: showLabel,
          showRepeatableRemoveButton: repeatable && repeatedIndex > 0,
          title: label
        }, renderLayout(otherProps)) : renderLayout(otherProps)))
      );
    };

    var _default = FieldSet;
    exports.default = _default;
    //# sourceMappingURL=FieldSet.es.js.map
  }
});
//# sourceMappingURL=FieldSet.es.js.map