Liferay.Loader.define("dynamic-data-mapping-form-field-type@5.0.83/hooks/useSyncValue.es", ['module', 'exports', 'require', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.useSyncValue = void 0;

    var _react = require("frontend-js-react-web$react");

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    /**
     * Use Sync Value to synchronize the initial value with the current internal
     * value, only update the internal value with the new initial value if the
     * values are different and when the value is not changed for more than ms.
     */
    var useSyncValue = function useSyncValue(newValue) {
      var isDelay = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      // Maintains the reference of the last value to check in later renderings if the
      // value is new or keeps the same, it covers cases where the value typed by
      // the user is sent to LayoutProvider but it does not descend with the new changes.
      var previousValueRef = (0, _react.useRef)(newValue);

      var _useState = (0, _react.useState)(newValue),
          _useState2 = _slicedToArray(_useState, 2),
          value = _useState2[0],
          setValue = _useState2[1];

      (0, _react.useEffect)(function () {
        var handler = setTimeout(function () {
          if (value !== newValue && previousValueRef.current !== newValue) {
            previousValueRef.current = newValue;
            setValue(newValue);
          }
        }, isDelay ? 300 : 0);
        return function () {
          clearTimeout(handler);
        };
      }, [isDelay, newValue, value]);
      return [value, setValue];
    };

    exports.useSyncValue = useSyncValue;
    //# sourceMappingURL=useSyncValue.es.js.map
  }
});
//# sourceMappingURL=useSyncValue.es.js.map